//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  PaleVioletRed
#property indicator_color2  DimGray
#property indicator_color3  DeepSkyBlue
#property indicator_color4  Aqua
#property indicator_color5  Magenta
#property indicator_style2  STYLE_DASHDOTDOT

extern int    AverageLength   = 20;
extern int    arrowSize       = 2;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
//
//
//
//
//

double bandmi[];
double bandup[];
double banddn[];
double arrowUp[];
double arrowDn[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,banddn);
   SetIndexBuffer(1,bandmi);
   SetIndexBuffer(2,bandup);
   SetIndexBuffer(3,arrowUp); SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,241);
   SetIndexBuffer(4,arrowDn); SetIndexStyle(4,DRAW_ARROW,0,arrowSize); SetIndexArrow(4,242);
   return(0);
}

//
//
//
//
//

double work[][2];
#define _upper 0
#define _lower 1

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

         //
         //
         //
         //
         //
         
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_upper] = High[i]*(1.0+2.0*(((High[i]-Low[i])/((High[i]+Low[i])/2.0))*1000.0)*0.001);
      work[r][_lower] = Low[i] *(1.0-2.0*(((High[i]-Low[i])/((High[i]+Low[i])/2.0))*1000.0)*0.001);
      bandmi[i] = 0;
      bandup[i] = 0;
      banddn[i] = 0;
         for (int k=0; k<AverageLength; k++)
         {
            bandmi[i] += Close[i+k];
            bandup[i] += work[r-k][_upper];
            banddn[i] += work[r-k][_lower];
         }
         bandmi[i] /= AverageLength;
         bandup[i] /= AverageLength;
         banddn[i] /= AverageLength;
         
         //
         //
         //
         //
         //
         
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         if (High[i]>=bandup[i] && High[i+1]<=bandup[i+1]) arrowDn[i] = bandup[i] + iATR(NULL,0,20,i)/2.0;
         if ( Low[i]<=banddn[i] &&  Low[i+1]>=banddn[i+1]) arrowUp[i] = banddn[i] - iATR(NULL,0,20,i)/2.0;   
      }
      
      //
      //
      //
      //
      //
    
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
      
        //
        //
        //
        //
        //
      
        if (arrowUp[whichBar+1] == EMPTY_VALUE && arrowUp[whichBar] != EMPTY_VALUE) doAlert(whichBar,"low price crossing lower band");
        if (arrowDn[whichBar+1] == EMPTY_VALUE && arrowDn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"high price crossing upper band");
      }         
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Headly acceleration bands ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Headly acceleration bands "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


  
   
   

